using System;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            int v, s;
            int i, j;
            int x;
            int l, d;
            int[,] Vodopad;
            int[,] Vodopad2;
            string[] temp = Console.ReadLine().Split(" ");
            v = Convert.ToInt32(temp[0]);
            s = Convert.ToInt32(temp[1]);
            Vodopad = new int[v + 2, s];
            Vodopad2 = new int[v + 2, s];
            for (i = 1; i < v + 1; i++)
            {
                temp = Console.ReadLine().Split(" ");
                for (j = 0; j < s; j++)
                {
                    Vodopad[i, j] = Convert.ToInt32(temp[j]);
                    Vodopad2[i, j] = 0;
                }

            }
            for (i = 0; i < s; i++)
            {
                Vodopad[0, i] = 1;
                Vodopad2[0, i] = 1;
            }
            for (i = 0; i < s; i++)
            {
                Vodopad[v + 1, i] = 1;
                Vodopad2[v + 1, i] = 0;
            }


            for (i = 0; i < v; i++)
            {
                for (j = 0; j < s; j++)
                {
                    //samo pravo
                    if (Vodopad[i + 1, j] == 1)
                    {
                        Vodopad2[i + 1, j] += Vodopad2[i, j];
                        continue;
                    }
                    //skroz leva ivica
                    if (Vodopad[i + 1, j] == 0 && j == 0)
                    {
                        l = j;
                        while (Vodopad[i + 1, l + 1] == 0)
                        {
                            l++;

                        }
                        Vodopad2[i + 1, l + 1] += Vodopad2[i, j];
                        continue;
                    }




                    //kad je skroz desna ivica
                    if (Vodopad[i + 1, j] == 0 && j == s - 1)
                    {
                        d = j;
                        while (Vodopad[i + 1, d - 1] == 0)
                        {
                            d--;

                        }
                        Vodopad2[i + 1, d - 1] += Vodopad2[i, j];
                        continue;
                    }



                    //levo desno ako je u sredini
                    if (Vodopad[i + 1, j] == 0)
                    {
                        if (Vodopad2[i, j] % 2 == 0)
                        {
                            l = d = j;
                            x = -1;
                            while (Vodopad[i + 1, l + x] == 0)
                            {


                                if (l - 1 == 0)
                                    x = 1;
                                    l += x;
                            }
                            Vodopad2[i + 1, l + x] += Vodopad2[i, j] / 2;
                            x = 1;
                            while (Vodopad[i + 1, d + x] == 0)
                            {
                                if (d + 1 == s - 1)
                                    x = -1;
                                d+=x;
                            }
                            
                            Vodopad2[i + 1, d +x] += Vodopad2[i, j] / 2;
                            continue;
                        }

                        if (Vodopad2[i, j] % 2 != 0)
                        {
                            if ((i + 1) % 2 == 0)
                            {
                                l = d = j;
                                x = 1;
                                while (Vodopad[i + 1, d + x] == 0)
                                {
                                    if (d + 1 == s - 1)
                                        x = -1;
                                    d += x;
                                }
                                Vodopad2[i + 1, d + x] += 1;
                                Vodopad2[i, j] -= 1;

                                
                                x = -1;
                                while (Vodopad[i + 1, l + x] == 0)
                                {


                                    if (l - 1 == 0)
                                        x = 1;
                                    l += x;
                                }
                                Vodopad2[i + 1, l + x] += Vodopad2[i, j] / 2;
                                x = 1;
                                while (Vodopad[i + 1, d + x] == 0)
                                {
                                    if (d + 1 == s - 1)
                                        x = -1;
                                    d += x;
                                }
                                
                                Vodopad2[i + 1, d +x] += Vodopad2[i, j] / 2;
                                continue;
                            }
                            if ((i + 1) % 2 != 0)
                            {
                                l = d = j;
                                x = -1;
                                while (Vodopad[i + 1, l + x] == 0)
                                {


                                    if (l - 1 == 0)
                                        x = 1;
                                    l += x;
                                }
                                Vodopad2[i + 1, l +x] += 1;
                                Vodopad2[i, j] -= 1;

                                
                                x = -1;
                                while (Vodopad[i + 1, l + x] == 0)
                                {


                                    if (l - 1 == 0)
                                        x = 1;
                                    l += x;
                                }
                                Vodopad2[i + 1, l + x] += Vodopad2[i, j] / 2;
                                x = 1;
                                while (Vodopad[i + 1, d + x] == 0)
                                {
                                    if (d + 1 == s - 1)
                                        x = -1;
                                    d += x;
                                }
                                
                                Vodopad2[i + 1, d + x] += Vodopad2[i, j] / 2;
                                continue;
                            }
                        }
                    }



                }
            }
            for (i = 0; i < s; i++)
                Console.Write("{0} ", Vodopad2[v, i]);


            


        }
    }
}